# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global desktopvendor city-fan.org

Name:		mgdiff
License:	MIT
Group:		Development/Tools
Version:	1.0
Release:	9.%{__distinit}%{__distvers}
Summary:	Compare files side by side
Url:		http://ftp.x.org/contrib/applications/mgdiff.README
Source0:	http://ftp.x.org/contrib/applications/mgdiff.tar.gz
Source1:	http://ftp.x.org/contrib/applications/mgdiff.README
Source2:	mgdiff.desktop
Patch0:		mgdiff-1.0.diff
BuildRoot:	%{_tmppath}/%{name}-%{version}-build-%(id -nu)
BuildRequires:	desktop-file-utils
Requires:	/usr/bin/diff

# Red Hat Linux: openmotif + XFree86
%if "%{__distinit}" == "rhl"
BuildRequires:	openmotif-devel, XFree86-devel
%global xmkmf /usr/X11R6/bin/xmkmf
%global x11bindir %{_prefix}/X11R6/bin
%global appdefdir %{_prefix}/X11R6/lib/X11/app-defaults
%global x11mandir %{_prefix}/X11R6/man
%endif

# Red Hat Enterprise Linux
%if "%{__distinit}" == "rhel"
# Red Hat Enterprise Linux 3: XFree86 + openmotif
%if "%(expr %{__distvers} '<' 4)" == "1"
BuildRequires:	openmotif-devel, XFree86, XFree86-devel
%global xmkmf /usr/X11R6/bin/xmkmf
%global x11bindir %{_prefix}/X11R6/bin
%global appdefdir %{_prefix}/X11R6/lib/X11/app-defaults
%global x11mandir %{_prefix}/X11R6/man
%endif
# Red Hat Enterprise Linux 4: X.org (monolithic) + openmotif
%if "%(expr %{__distvers} '=' 4)" == "1"
BuildRequires:	openmotif-devel
%global xmkmf /usr/X11R6/bin/xmkmf
%global x11bindir %{_prefix}/X11R6/bin
%global appdefdir %{_prefix}/X11R6/lib/X11/app-defaults
%global x11mandir %{_prefix}/X11R6/man
%endif
# Red Hat Enterprise Linux > 4: Modular X.org + openmotif
%if "%(expr %{__distvers} '>' 4)" == "1"
BuildRequires: openmotif-devel, xmkmf, libXmu-devel, libXpm-devel
%global xmkmf /usr/bin/xmkmf
%global x11bindir %{_bindir}
%global appdefdir %{_datadir}/X11/app-defaults
%global x11mandir %{_mandir}
%endif
%endif

# Fedora
%if  "%{__distinit}" == "fc"
# FC 1..2: Monolithic XFree86 + openmotif
%if "%{__distvers}" == "1" || "%{__distvers}" == "2"
BuildRequires:	openmotif-devel, XFree86-devel
%global xmkmf /usr/X11R6/bin/xmkmf
%global x11bindir %{_prefix}/X11R6/bin
%global appdefdir %{_prefix}/X11R6/lib/X11/app-defaults
%global x11mandir %{_prefix}/X11R6/man
%endif
# FC 3..4: Monolithic X.org + openmotif
%if "%{__distvers}" == "3" || "%{__distvers}" == "4"
BuildRequires:	openmotif-devel
%global xmkmf /usr/X11R6/bin/xmkmf
%global x11bindir %{_prefix}/X11R6/bin
%global appdefdir %{_prefix}/X11R6/lib/X11/app-defaults
%global x11mandir %{_prefix}/X11R6/man
%endif
# FC5: Modular X.org + openmotif
%if "%(expr %{__distvers} '=' 5)" == "1"
BuildRequires: openmotif-devel, xmkmf, libXmu-devel, libXpm-devel
%global xmkmf /usr/bin/xmkmf
%global x11bindir %{_bindir}
%global appdefdir %{_datadir}/X11/app-defaults
%global x11mandir %{_mandir}
%endif
# FC6 onwards: Modular X.org + lesstif
%if "%(expr %{__distvers} '>' 5)" == "1"
BuildRequires: lesstif-devel, xmkmf, libXmu-devel, libXpm-devel
%global xmkmf /usr/bin/xmkmf
%global x11bindir %{_bindir}
%global appdefdir %{_datadir}/X11/app-defaults
%global x11mandir %{_mandir}
%endif
%endif

%description
Mgdiff is a graphical front end to the Unix diff command based upon X11
and the Motif widget set. It allows the user to select two files for
comparison, runs the diff command, parses the output and presents the
results graphically.

%prep
%setup -q -n %{name}

# Linux fixes from SuSE, tweaked to apply against slightly later upstream tarball
%patch0

# Upstream README
cp -a %{SOURCE1} README

%{xmkmf} -a

%build
make CCOPTIONS="%{optflags}"

%install
rm -rf %{buildroot}
make INSTPGMFLAGS= DESTDIR=%{buildroot} install install.man
desktop-file-install \
	--vendor %{desktopvendor} \
	--add-category X-Red-Hat-Base \
	--add-category X-Fedora \
	--dir %{buildroot}%{_datadir}/applications \
	%{SOURCE2}

# xmkmf makes this sometimes
rm -f %{buildroot}/usr/lib/X11/app-defaults

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README
%{_datadir}/applications/*.desktop
%{x11bindir}/mgdiff
%{appdefdir}/Mgdiff
%doc %{x11mandir}/man1/mgdiff.1x*

%changelog
* Tue Aug  2 2011 Paul Howarth <paul@city-fan.org> 1.0-9
- Add real upstream source URL and use that tarball
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed May 26 2010 Paul Howarth <paul@city-fan.org> 1.0-8
- Fix dist tag for RHEL-6 Beta

* Thu Feb 25 2010 Paul Howarth <paul@city-fan.org> 1.0-7
- Dist tag for Rawhide no longer needs special-casing

* Tue Jun 23 2009 Paul Howarth <paul@city-fan.org> 1.0-6
- Define RPM macros in global scope
- Add URL tag and fix license tag to placate rpmlint

* Mon Jun  5 2007 Paul Howarth <paul@city-fan.org> 1.0-5
- Fix build and dist tag for Fedora 7 onwards
- Support builds on Red Hat Enterprise Linux 5 onwards

* Mon Sep 11 2006 Paul Howarth <paul@city-fan.org> 1.0-4
- Fix distribution-detection to work with development releases
- Tweak buildreq conditionals to work with more distribution releases
- Build against lesstif for FC6 onwards
- RHEL3 needs XFree86 for /usr/X11R6/bin/archexec

* Mon Aug  7 2006 Paul Howarth <paul@city-fan.org> 1.0-3
- Add buildreq libXpm-devel for modular X

* Wed Jul 12 2006 Paul Howarth <paul@city-fan.org> 1.0-2
- Enable build on Fedora Core 5 (modular X)

* Fri Feb 10 2006 Paul Howarth <paul@city-fan.org> 1.0-1
- Port from SuSE to Fedora Core 4

* Tue Apr 27 2004 - werner@ssue.de
- Avoid compiler warnings
- Use mkstemp() instead of tempnam()
* Sun Jan 11 2004 - adrian@suse.de
- build as user
* Sat Aug 16 2003 - adrian@suse.de
- add desktop file
* Thu Jun 12 2003 - kukuk@suse.de
- Use BuildRoot, fix filelist
* Tue Sep 17 2002 - ro@suse.de
- removed bogus self-provides
* Sat May 12 2001 - schwab@suse.de
- Fix missing declarations.
* Tue Nov 21 2000 - ro@suse.de
- use openmotif
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec
* Mon Jul 12 1999 - uli@suse.de
- now builds with lesstif
* Mon Nov 09 1998 - ro@suse.de
- use basename from libc for glibc
* Thu May 07 1998 - fehr@suse.de
- add library -lXp for Motif 2.1
* Tue Dec 09 1997 - ro@suse.de
- build static and dynamic version
* Tue Jun 24 1997 - werner@suse.de
- recognise all latin1 umlauts as characters in system with
  and without correct working locale
* Thu Jan 02 1997 - kfr@suse.de
- recognise german umlauts as text: dirty hack, but also call "setlocale"
  for correctly installed systems...
